import requests, json, time, re
from bs4 import BeautifulSoup
from datetime import datetime
from unidecode import unidecode

domain = ["fullmatchtv.com"]
site_name = "Full Match TV"
short_id = "FMTV"
user_agent = "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/87.0.4280.141 Safari/537.36"

def get_games():
    games = []
    for league in ["NBA", "NFL", "NHL", "MLB"]:
        r_home = requests.get("https://fullmatchtv.com/" + league, headers={"Referer": domain[0], "User-Agent": user_agent}).text
        soup_home = BeautifulSoup(r_home, "html.parser")
        for game in soup_home.select("div.td_module_flex"):
            game_href = game.select_one("a.td-image-wrap").get("href")
            game_title = game.select_one("a.td-image-wrap").get("title")
            game_icon = re.compile(r"url\('(.+?)'\)").findall(game.select_one("span.entry-thumb").get("style"))[0]
            game_time = datetime(*(time.strptime(game.select_one("time.entry-date").get("datetime"), "%Y-%m-%dT%H:%M:%S+00:00")[:6])).replace(hour=0, minute=0, second=0)
            games.append({
                "title": unidecode(game_title),
                "links": [game_href],
                "icon": game_icon,
                "league": league,
                "time": game_time,
            })
    return games

def get_m3u8(url):
    r_game = requests.get(url, headers={"Referer": domain[0], "User-Agent": user_agent}).text
    # if "https://streamtape.com/e" in r_game:
    #     embed_url = re.compile(r'src="(https://streamtape.com/e/.+?/)"').findall(r_game)[0]
    #     r = requests.get(embed_url, headers={"User-Agent": user_agent}).text
    #     soup = BeautifulSoup(r, "html.parser")
    #     mp4 = ""
    #     scripts = soup.find_all("script")
    #     for script in scripts:
    #         script_str = str(script)
    #         if "document.getElementById('" in script_str:
    #             mp4 = "https:" + eval(script_str[script_str.index("= ") + 2:].replace(";</script>", ""))
    #             break
    #     return mp4 + "&stream=1|User-Agent=%s&Referer=%s" % (user_agent, url) if mp4 != "" else url
    if "//ok.ru/videoembed" in r_game:
        embed_url = "https:" + re.compile(r'src="(//ok.ru/videoembed/.+?)"').findall(r_game)[0]
        r_embed = requests.get(embed_url, headers={"User-Agent": user_agent}).text
        try: 
            import html
            embed_json = json.loads(html.unescape(re.compile(r'data-options="(.+?)"').findall(r_embed)[0]))
        except: # Python 2
            from HTMLParser import HTMLParser
            embed_json = json.loads(HTMLParser().unescape(re.compile(r'data-options="(.+?)"').findall(r_embed)[0]))
        metadata_json = json.loads(embed_json["flashvars"]["metadata"])
        return metadata_json["hlsManifestUrl"] + "|User-Agent=%s" % (user_agent)
    return url
